/*	Project sci877
	Serial com. interface PIC16F877
*/

#include <pic.h>

__CONFIG(
	  PWRTEN
	& BORDIS
	& UNPROTECT
	& WDTDIS
	& LVPDIS
	& HS
	);

__IDLOC(F877);

#define XON 17
#define XOFF 19

unsigned char xf;
unsigned char rbuf[16];
unsigned char wp;
unsigned char rp;
unsigned char dc;

void interrupt entry(void){
	unsigned char c;

	if(RCIF){
		c = RCREG;
		if(c == XON || c == XOFF){
			xf = c;
			return;
		}

		if(dc == 16) return;
		rbuf[wp] = c;
		wp++;
		wp &= 15;
		dc++;
		if(dc == 12){
			while(TXIF == 0);
			TXREG = XOFF;
		}
	}
}

unsigned char getchr(void){
	unsigned char c;

	while(dc == 0);
	RCIE = 0;
	c = rbuf[rp];
	rp++;
	rp &= 15;
	dc --;
	if(dc == 12){
		while(TXIF == 0);
		TXREG = XON;
	}
	RCIE = 1;
	return(c);
}

void putchr(unsigned char c){
	while(xf == XOFF);
	while(TXIF == 0);
	TXREG = c;
}

void puts(const unsigned char *s){
	while(*s) putchr(*s++);
}

void main(void){

	PORTC = 0;
	TRISC = 0b10000000;

	SPBRG = 128;
	TXSTA = 0b00100100;
	RCSTA = 0b10010000;

	wp = 0;
	rp = 0;
	dc = 0;
	xf = XON;

	RCIE = 1;
	PEIE = 1;
	ei();

	puts("Hit some key for test\n");
	puts("\n");

	while(1){
		putchr(getchr());
	}
}
